力扣题解( 最长递增子序列的个数)

673. 最长递增子序列的个数

给定一个未排序的整数数组 nums , 返回最长递增子序列的个数 。

注意 这个数列必须是 严格 递增的。

思路:

用一个maxlen表示当前最长递增数组的长度,maxcount表示最大长度。当进下标为i的元素时,将其和j(0-i-1)之间的元素比较,若大小大于numj,则由包含j的最大子序列加i仍可能是最大子序列,此时判断当前包含i的最大长度和由j加上i元素的最大长度比较,若大于则更新最大长度和数量(因为此时相当于找了一个更大的来做最长子序列,因此都需要重新计算),若小于则忽略,若等于则数量相加。

再遍历完(0-i-1)后,要更新maxlen和maxcount,若当前的maxlen等于leni,则表示以i位置结尾的最大长度和(0-i-1)中某个最大长度一致,则maxcount等于counti+maxcount,若maxlen小于leni,则maxlen更新,maxcount更新。若maxlen大于leni,则表示最长不是包含i的,则不变。

就是一次更新是只看当前i位置的len和count,一次比较是求(0-i)里的最大len和最大count。

复制代码
class Solution {
public:
    int findNumberOfLIS(vector<int>& nums) {
     int n=nums.size();
     vector<int>len(n,1);
  //   len[0]=1;
     vector<int>count(n,1);
     //count[0]=1;
     int retlen=1,retcount=1;
     for(int i=1;i<n;i++)
     {
        for(int j=0;j<i;j++)
        {
            if(nums[i]>nums[j])
            {
               if(len[i]<len[j]+1)
               {
                len[i]=len[j]+1;
                count[i]=count[j];
               }
               else if(len[i]==len[j]+1)
               {
                count[i]+=count[j];
               }
            }
        }
        if(retlen==len[i])
        {
            retcount+=count[i];
        }
        else if(retlen<len[i])
        {
            retcount=count[i];
            retlen=len[i];
        }
     }

     return retcount;
    }
};
相关推荐
hetao17338373 小时前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
Zootopia6263 小时前
飞行力学知识梳理1|飞行性能与稳定性
人工智能·python·算法·机器学习·无人机·学习方法·信息与通信
longlongzihan3 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
2601_960356384 小时前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah5 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO95 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician5 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
垆边人似月.5 小时前
VLAN 资源池(100~200 分档)
数据结构·算法
潼心1412o6 小时前
C++初阶(长期更新)第6讲:类和对象(下)
开发语言·c++·算法
星光开发者6 小时前
基于决策树随机森林算法的小说推荐系统的设计与实现-计算机毕设【课程设计】78485
vue.js·算法·微信小程序·django·php·课程设计·express